' Einfaches Uhrenprogramm fr die modifizierte LP- Bascom- Hardware (mit 32768- Hz- Uhrenquarz)
'
' Der Mikrocontroller- Takt wird weiterhin durch den internen RC- Oszillator geliefert;
' durch den Befehl ASSR.AS2 = 1 wird Timer2 asynchron mit dem Takt des Uhrenquarzes betrieben.

' Als "optisches Lebenszeichen" wird eine LED an PB1 bei jedem Sekundentakt getoggelt
'
' Die Uhrzeitb wird mit 19200 bit/s aufs Terminal gesendet
'
'----------------------------------------------------------
$regfile = "m88def.dat"
$crystal = 8000000                                          ' 8 MHz- Takt vom RC-Oszillator
$baud = 19200

On Timer2 Ontimer2                                          'Interrupt-Routine fr Timer2-Overflow

Dim S As Byte
Dim M As Byte
Dim H As Byte


Acsr.acd = 1                                                ' Analogen Komparator ausschalten
Assr.as2 = 1                                                ' Timer2- Asynchron- Betrieb
Tccr2b = &B00000101                                         ' Vorteiler fr Timer2 auf 128 setzen
Timsk2.toie2 = 1                                            ' Timer2-Overflow-Interrupt an

Sreg.7 = 1                                                  ' Interrupts global einschalten

Ddrb.1 = 1
Ddrb.2 = 0

Portb = &B11111101                                          ' Pullups einschalten, damit die Eingnge nicht floaten
Portc = &B11111111
Portd = &B11111111





' Hauptprogramm

 Do

       If S = 60 Then
          S = 0
          M = M + 1
          If M = 60 Then
             H = H + 1
             If H = 24 Then
                H = 0
             End If
          End If
       End If

       Print H ; " : " ; M ; " : " ; S ; "    {013}" ;

       Idle
Loop




'Interrupt- Routine

Ontimer2:                                                   'Timer2-Overflow-Interrupt-Routine

  S = S + 1
  Portb.1 = Not Portb.1                                     ' LED an Portb.1 toggeln

Return
